<template>
  <v-card>
    <v-card-title>
      {{ tableTitle }}
      <v-spacer />
      <v-text-field
        v-model="search"
        append-icon="mdi-magnify"
        :label="searchText"
        single-line
        hide-details
      />
    </v-card-title>
    <v-data-table
      :headers="headers"
      :loading="loading"
      :items="items"
      :page="page"
      :items-per-page="itemsPerPage"
      :search="search"
      :server-items-length="totalItems"
      :single-select="singleSelect"
      :show-select="showSelect"
      hide-default-footer
      @click:row="rowClick"
      @update:page="paginate"
    >
      <template v-if="fullName" #item.full_name="{ item }">
        {{ item.user.name }} {{ item.user.fatherLastname }} {{ item.user.motherLastname }}
      </template>

      <template #item.user.typeDocument="{ item }">
        <v-chip
          class="ma-2"
          :color="'#409EFF'"
          outlined
          dark
        >
          {{ item.user.typeDocument }}
        </v-chip>
      </template>

      <template #item.isBlocked="{ item }">
        <v-chip
          v-if="!item.isBlocked"
          :color="getColor(item.isBlocked)"
          dark
          outlined
          class="active"
        >
          <span>Activo</span>
        </v-chip>
        <v-chip
          v-else
          :color="getColor(item.isBlocked)"
          dark
          outlined
        >
          Bloqueado
        </v-chip>
      </template>
    </v-data-table>
    <slot />
    <!----
    <div class="text-center">
      <v-pagination
        v-model="page"
        :length="Math.ceil(totalItems/itemsPerPage)"
        :total-visible="7"
      ></v-pagination>
    </div>---->
  </v-card>
</template>

<script>
export default {
  name: 'SearchTable',
  props: {
    'tableTitle': {
      type: String,
      default: '',
    },
    'headers': {
      type: Array,
      default: null,
    },
    'fullName': {
      default: false,
      type: Boolean,
    },
    'loading': {
      default: false,
      type: Boolean,
    },
    'items': {
      default: null,
      type: Array,
    },
    'page': {
      default: 1,
      type: Number,
    },
    'itemsPerPage': {
      default: 10,
      type: Number,
    },
    'searchText': {
      default: 'Buscar',
      type: String,
    },
    'totalItems': {
      default: 1,
      type: Number,
    },
    'singleSelect': {
      default: false,
      type: Boolean,
    },
    'showSelect': {
      default: false,
      type: Boolean,
    },
  },
  data() {
    return {
      search: '',
    };
  },
  methods: {
    getColor(isBlocked) {
      if (!isBlocked) { return 'green'; } else { return 'red'; }
    },
    rowClick(item, row) {
      this.$emit('selectRow', item, row);
      this.$emit('edited', item.id);
    },
    paginate() {
      this.$emit('eventPagination', this.page);
    },
  },
};
</script>
